# all files / ol/format/ igc.js

89.66% Statements 78/87
65.63% Branches 21/32
42.86% Functions 3/7
89.66% Lines 78/87

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    2331×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    7×

    7×

    7×

    7×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    6×
    6×

    6×
    6×
    6×
    6×
    6×
    6×
    6×
    6×
    82×
    82×
    82×
    16×
    16×
    16×
    16×
    16×
    16×
    16×

    16×
    16×

    16×
    16×

    16×

    16×
    4×

    16×
    16×

    66×
    40×
    40×
    4×
    4×
    4×

    36×
    36×
    32×

    6×
    2×

    4×
    4×

    4×
    4×

    4×
    4×

    1×

    1×
    3×
    3×
    2×

    1×

    1×

    1×

    1×

    1×

    1×
     goog.provide('ol.format.IGC');

    goog.require('ol');
    goog.require('ol.Feature');
    goog.require('ol.format.Feature');
    goog.require('ol.format.IGCZ');
    goog.require('ol.format.TextFeature');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.LineString');
    goog.require('ol.proj');

    /**
     * @classdesc
     * Feature format for `*.igc` flight recording files.
     *
     * @constructor
     * @extends {ol.format.TextFeature}
     * @param {olx.format.IGCOptions=} opt_options Options.
     * @api
     */
    ol.format.IGC = function(opt_options) {

      var options = opt_options ? opt_options : {};

      ol.format.TextFeature.call(this);

      /**
       * @inheritDoc
       */
      this.defaultDataProjection = ol.proj.get('EPSG:4326');

      /**
       * @private
       * @type {ol.format.IGCZ}
       */
      this.altitudeMode_ = options.altitudeMode ?
        options.altitudeMode : ol.format.IGCZ.NONE;

    };
    ol.inherits(ol.format.IGC, ol.format.TextFeature);

    /**
     * @const
     * @type {RegExp}
     * @private
     */
    ol.format.IGC.B_RECORD_RE_ =
        /^B(\d{2})(\d{2})(\d{2})(\d{2})(\d{5})([NS])(\d{3})(\d{5})([EW])([AV])(\d{5})(\d{5})/;

    /**
     * @const
     * @type {RegExp}
     * @private
     */
    ol.format.IGC.H_RECORD_RE_ = /^H.([A-Z]{3}).*?:(.*)/;

    /**
     * @const
     * @type {RegExp}
     * @private
     */
    ol.format.IGC.HFDTE_RECORD_RE_ = /^HFDTE(\d{2})(\d{2})(\d{2})/;

    /**
     * A regular expression matching the newline characters `\r\n`, `\r` and `\n`.
     *
     * @const
     * @type {RegExp}
     * @private
     */
    ol.format.IGC.NEWLINE_RE_ = /\r\n|\r|\n/;

    /**
     * Read the feature from the IGC source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Read options.
     * @return {ol.Feature} Feature.
     * @api
     */
    ol.format.IGC.prototype.readFeature;

    /**
     * @inheritDoc
     */
    ol.format.IGC.prototype.readFeatureFromText = function(text, opt_options) {
      var altitudeMode = this.altitudeMode_;
      var lines = text.split(ol.format.IGC.NEWLINE_RE_);
      /** @type {Object.<string, string>} */
      var properties = {};
      var flatCoordinates = [];
      var year = 2000;
      var month = 0;
      var day = 1;
      var lastDateTime = -1;
      var i, ii;
      for (i = 0, ii = lines.length; i < ii; ++i) {
        var line = lines[i];
        var m;
        if (line.charAt(0) == 'B') {
          m = ol.format.IGC.B_RECORD_RE_.exec(line);
          Eif (m) {
            var hour = parseInt(m[1], 10);
            var minute = parseInt(m[2], 10);
            var second = parseInt(m[3], 10);
            var y = parseInt(m[4], 10) + parseInt(m[5], 10) / 60000;
            Iif (m[6] == 'S') {
              y = -y;
            }
            var x = parseInt(m[7], 10) + parseInt(m[8], 10) / 60000;
            Iif (m[9] == 'W') {
              x = -x;
            }
            flatCoordinates.push(x, y);
            Iif (altitudeMode != ol.format.IGCZ.NONE) {
              var z;
              if (altitudeMode == ol.format.IGCZ.GPS) {
                z = parseInt(m[11], 10);
              } else if (altitudeMode == ol.format.IGCZ.BAROMETRIC) {
                z = parseInt(m[12], 10);
              } else {
                z = 0;
              }
              flatCoordinates.push(z);
            }
            var dateTime = Date.UTC(year, month, day, hour, minute, second);
            // Detect UTC midnight wrap around.
            if (dateTime < lastDateTime) {
              dateTime = Date.UTC(year, month, day + 1, hour, minute, second);
            }
            flatCoordinates.push(dateTime / 1000);
            lastDateTime = dateTime;
          }
        } else if (line.charAt(0) == 'H') {
          m = ol.format.IGC.HFDTE_RECORD_RE_.exec(line);
          if (m) {
            day = parseInt(m[1], 10);
            month = parseInt(m[2], 10) - 1;
            year = 2000 + parseInt(m[3], 10);
          } else {
            m = ol.format.IGC.H_RECORD_RE_.exec(line);
            if (m) {
              properties[m[1]] = m[2].trim();
            }
          }
        }
      }
      if (flatCoordinates.length === 0) {
        return null;
      }
      var lineString = new ol.geom.LineString(null);
      var layout = altitudeMode == ol.format.IGCZ.NONE ?
        ol.geom.GeometryLayout.XYM : ol.geom.GeometryLayout.XYZM;
      lineString.setFlatCoordinates(layout, flatCoordinates);
      var feature = new ol.Feature(ol.format.Feature.transformWithOptions(
          lineString, false, opt_options));
      feature.setProperties(properties);
      return feature;
    };

    /**
     * Read the feature from the source. As IGC sources contain a single
     * feature, this will return the feature in an array.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Read options.
     * @return {Array.<ol.Feature>} Features.
     * @api
     */
    ol.format.IGC.prototype.readFeatures;

    /**
     * @inheritDoc
     */
    ol.format.IGC.prototype.readFeaturesFromText = function(text, opt_options) {
      var feature = this.readFeatureFromText(text, opt_options);
      if (feature) {
        return [feature];
      } else {
        return [];
      }
    };

    /**
     * Read the projection from the IGC source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @return {ol.proj.Projection} Projection.
     * @api
     */
    ol.format.IGC.prototype.readProjection;

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.IGC.prototype.writeFeatureText = function(feature, opt_options) {};

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.IGC.prototype.writeFeaturesText = function(features, opt_options) {};

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.IGC.prototype.writeGeometryText = function(geometry, opt_options) {};

    /**
     * Not implemented.
     * @inheritDoc
     */
    ol.format.IGC.prototype.readGeometryFromText = function(text, opt_options) {};